//-----------------------------------------------------------------------------
// Torque Game Engine 
// Copyright (C) GarageGames.com, Inc.
//-----------------------------------------------------------------------------

// Load dts shapes and merge animations
datablock TSShapeConstructor(R2D2Dts)
{
	baseShape  = "./R2D2.dts";
	sequence0  = "./R2D2_root.dsq root";

	sequence1  = "./R2D2_run.dsq run";
	sequence2  = "./R2D2_run.dsq walk";
	sequence3  = "./R2D2_run.dsq back";
	sequence4  = "./R2D2_run.dsq side";

	sequence5  = "./R2D2_root.dsq crouch";
	sequence6  = "./R2D2_run.dsq crouchRun";
	sequence7  = "./R2D2_run.dsq crouchBack";
	sequence8  = "./R2D2_run.dsq crouchSide";

	sequence9  = "./R2D2_root.dsq look";
	sequence10 = "./R2D2_look.dsq headside";
	sequence11 = "./R2D2_root.dsq headUp";

	sequence12 = "./R2D2_root.dsq jump";
	sequence13 = "./R2D2_root.dsq standjump";
	sequence14 = "./R2D2_root.dsq fall";
	sequence15 = "./R2D2_root.dsq land";

	sequence16 = "./R2D2_armReady.dsq armAttack";
	sequence17 = "./R2D2_armReady.dsq armReadyLeft";
	sequence18 = "./R2D2_armReady.dsq armReadyRight";
	sequence19 = "./R2D2_armReady.dsq armReadyBoth";
	sequence20 = "./R2D2_armReady.dsq spearready";  
	sequence21 = "./R2D2_armReady.dsq spearThrow";

	sequence22 = "./R2D2_root.dsq talk";  

	sequence23 = "./R2D2_root.dsq death1"; 
	
	sequence24 = "./R2D2_armReady.dsq shiftUp";
	sequence25 = "./R2D2_armReady.dsq shiftDown";
	sequence26 = "./R2D2_armReady.dsq shiftAway";
	sequence27 = "./R2D2_armReady.dsq shiftTo";
	sequence28 = "./R2D2_armReady.dsq shiftLeft";
	sequence29 = "./R2D2_armReady.dsq shiftRight";
	sequence30 = "./R2D2_armReady.dsq rotCW";
	sequence31 = "./R2D2_armReady.dsq rotCCW";

	sequence32 = "./R2D2_root.dsq undo";
	sequence33 = "./R2D2_armReady.dsq plant";

	sequence34 = "./R2D2_root.dsq sit";

	sequence35 = "./R2D2_armReady.dsq wrench";

   sequence36 = "./R2D2_armReady.dsq activate";
   sequence37 = "./R2D2_armReady.dsq activate2";

   sequence38 = "./R2D2_armReady.dsq leftrecoil";
};    

datablock DebrisData( R2D2Debris )
{
   explodeOnMaxBounce = false;

   elasticity = 0.15;
   friction = 0.5;

   lifetime = 4.0;
   lifetimeVariance = 0.0;

   minSpinSpeed = 40;
   maxSpinSpeed = 600;

   numBounces = 5;
   bounceVariance = 0;

   staticOnMaxBounce = true;
   gravModifier = 1.0;

   useRadiusMass = true;
   baseRadius = 1;

   velocity = 20.0;
   velocityVariance = 12.0;
};             

datablock PlayerData(R2D2Armor : HorseArmor)
{
   renderFirstPerson = false;
   emap = false;
   
   className = Armor;
   shapeFile = "./R2D2.dts";
   cameraMaxDist = 4;
   cameraTilt = 0.261;//0.174 * 2.5; //~25 degrees
   cameraVerticalOffset = 1.0;
     
   cameraDefaultFov = 90.0;
   cameraMinFov = 5.0;
   cameraMaxFov = 120.0;
   
   //debrisShapeName = "~/data/shapes/player/debris_player.dts";
   //debris = R2D2Debris;

   aiAvoidThis = true;

   minLookAngle = -1.5708;
   maxLookAngle = 1.5708;
   maxFreelookAngle = 3.0;

   mass = 90;
   drag = 0.1;
   density = 0.7;
   maxDamage = 250;
   maxEnergy =  10;
   repairRate = 0.33;

   rechargeRate = 0.4;

   runForce = 28 * 90;
   runEnergyDrain = 0;
   minRunEnergy = 0;
   maxForwardSpeed = 12;
   maxBackwardSpeed = 6;
   maxSideSpeed = 1;

   maxForwardCrouchSpeed = 12;
   maxBackwardCrouchSpeed = 6;
   maxSideCrouchSpeed = 0;

   maxForwardProneSpeed = 0;
   maxBackwardProneSpeed = 0;
   maxSideProneSpeed = 0;

   maxForwardWalkSpeed = 0;
   maxBackwardWalkSpeed = 0;
   maxSideWalkSpeed = 0;

   maxUnderwaterForwardSpeed = 8.4;
   maxUnderwaterBackwardSpeed = 7.8;
   maxUnderwaterSideSpeed = 7.8;

   jumpForce = 6 * 100; //8.3 * 90;
   jumpEnergyDrain = 0;
   minJumpEnergy = 0;
   jumpDelay = 0;

   minJetEnergy = 0;
	jetEnergyDrain = 0;
	canJet = 0;

   minImpactSpeed = 250;
   speedDamageScale = 3.8;

   boundingBox			= vectorScale("1 1 1.6", 4);
   crouchBoundingBox	= vectorScale("1 1 1.6", 4);
   
   pickupRadius = 0.75;
   
   // Foot Prints
   //decalData   = R2D2Footprint;
   //decalOffset = 0.25;
	
   jetEmitter = "";
   jetGroundEmitter = "";
   jetGroundDistance = 4;
  
   //footPuffEmitter = LightPuffEmitter;
   footPuffNumParts = 10;
   footPuffRadius = 0.25;

   //dustEmitter = LiftoffDustEmitter;

   splash = PlayerSplash;
   splashVelocity = 4.0;
   splashAngle = 67.0;
   splashFreqMod = 300.0;
   splashVelEpsilon = 0.60;
   bubbleEmitTime = 0.1;
   splashEmitter[0] = PlayerFoamDropletsEmitter;
   splashEmitter[1] = PlayerFoamEmitter;
   splashEmitter[2] = PlayerBubbleEmitter;
   mediumSplashSoundVelocity = 10.0;   
   hardSplashSoundVelocity = 20.0;   
   exitSplashSoundVelocity = 5.0;

   // Controls over slope of runnable/jumpable surfaces
   runSurfaceAngle  = 85;
   jumpSurfaceAngle = 86;

   minJumpSpeed = 20;
   maxJumpSpeed = 30;

   horizMaxSpeed = 68;
   horizResistSpeed = 33;
   horizResistFactor = 0.35;

   upMaxSpeed = 80;
   upResistSpeed = 25;
   upResistFactor = 0.3;
   
   footstepSplashHeight = 0.35;

   //NOTE:  some sounds commented out until wav's are available

   //JumpSound			= R2D2JumpSound;

   // Footstep Sounds
//   FootSoftSound        = R2D2FootFallSound;
//   FootHardSound        = R2D2FootFallSound;
//   FootMetalSound       = R2D2FootFallSound;
//   FootSnowSound        = R2D2FootFallSound;
//   FootShallowSound     = R2D2FootFallSound;
//   FootWadingSound      = R2D2FootFallSound;
//   FootUnderwaterSound  = R2D2FootFallSound;
   //FootBubblesSound     = FootLightBubblesSound;
   //movingBubblesSound   = ArmorMoveBubblesSound;
   //waterBreathSound     = WaterBreathMaleSound;

   //impactSoftSound      = ImpactLightSoftSound;
   //impactHardSound      = ImpactLightHardSound;
   //impactMetalSound     = ImpactLightMetalSound;
   //impactSnowSound      = ImpactLightSnowSound;
   
   impactWaterEasy      = Splash1Sound;
   impactWaterMedium    = Splash1Sound;
   impactWaterHard      = Splash1Sound;
   
   groundImpactMinSpeed    = 10.0;
   groundImpactShakeFreq   = "4.0 4.0 4.0";
   groundImpactShakeAmp    = "1.0 1.0 1.0";
   groundImpactShakeDuration = 0.8;
   groundImpactShakeFalloff = 10.0;
   
   //exitingWater         = ExitingWaterLightSound;

   // Inventory Items
	maxItems   = 10;	//total number of bricks you can carry
	maxWeapons = 5;		//this will be controlled by mini-game code
	maxTools = 5;
	
	uiName = "R2D2";
	rideable = false;

	canRide = true;
	showEnergyBar = false;
	paintable = true;

	//brickImage = R2D2BrickImage;	//the imageData to use for brick deployment

};